type width = int;;
type height = int;;
type t = (width * height * Strng.t list);;

let height (_, h, _) = h;;
let width (w, _, _) = w;;
let rec above (w1, h1, p1) (w2, h2, p2) =
 if w1 = w2 then
  (w1, h1 + h2, p1 @ p2)
 else 
  failwith "Picture.above: different widths"
;;
let rec beside (w1, h1, p1) (w2, h2, p2) =
 if h1 = h2 then
  (w1 + w2, h1, Lst.zip2_with (@) p1 p2)
 else
  failwith "Picture.beside: different heights"
;;
let to_strng (_, _, p) = Strng.join ['\n'] p;; 
let stack ps = Lst.fold1 above ps;;
let spread ps = Lst.fold1 beside ps;;
let pixel c = (1, 1, [[c]]);;
let row s = spread (Lst.map pixel s);;
let empty w h =
 let line = Lst.init ' ' w in
 let rows = Lst.init line h in
 stack (Lst.map row rows)
;;
let stack_with h ps =
 Lst.fold1 (fun p q -> above (above p (empty (width q) h)) q) ps
;;
let spread_with w ps =
 Lst.fold1 (fun p q -> beside (beside p (empty w (height q))) q) ps
;;
let tile pss = stack (Lst.map spread pss);;
let tile_with w h pss = stack_with h (Lst.map (spread_with w) pss);;
let toplevel_printer ((_, _, s) : t) =
 let print_line s =
  Format.printf "%s\n" (String.escaped (Strng.to_string s))
 in
 Format.printf "\n";
 let _ = Lst.map print_line s in ()
;;
